public class Bank {
 // Attribute
 String name;
 BankKonto[] konten;
 int anzahlKonten;
 
 // Konstruktor
 public Bank(String name, int maxAnzahlKonten) {
  this.name = name;
  this.konten = new BankKonto[maxAnzahlKonten];
  this.anzahlKonten = 0;
 }
 
 // Methoden
 public String getName() {
  return this.name;
 }
 // Konto eroeffnen
 public int kontoEroeffnen(double anfangsBetrag) {
  // Ist noch Platz?
  if (anzahlKonten >= konten.length) {
   // schaffe Platz, indem ein doppelt so 
   // grosses Array angelegt wird und 
   // die Daten kopiert werden.
   int maxAnzahlKonten = konten.length;
   BankKonto[] kontenNeu = new BankKonto[maxAnzahlKonten*2];
   for(int i=0;i < anzahlKonten;i++) {
      kontenNeu[i] = konten[i];
   }
   this.konten = kontenNeu;
  }
  // jetzt ist sicher genuegend Platz
  BankKonto neuesKonto = new BankKonto(anfangsBetrag);
  this.konten[this.anzahlKonten] = neuesKonto;
  this.anzahlKonten++;
  return neuesKonto.getKontoNummer();
 }
 // BankKonto suchen
 public BankKonto sucheBankKonto(int kontoNummer) {
   for (int i = 0; i < anzahlKonten; i++) {
     BankKonto ergebnis = this.konten[i];    // lokale Variable
     if (ergebnis.getKontoNummer() == kontoNummer) 
       { return ergebnis; }                  // gefunden
    }
   return null;                              // erfolglos
 }
 // einzahlen
 public boolean einzahlen(int kontoNummer,double betrag) {
   BankKonto konto = this.sucheBankKonto(kontoNummer);
   if (konto == null) { return false; } // Konto existiert nicht
   else { konto.einzahlen(betrag); return true; }
 }
 // abheben
 public boolean abheben(int kontoNummer,double betrag) {
   BankKonto konto = this.sucheBankKonto(kontoNummer);
   if (konto == null) { return false; } // Konto existiert nicht
   else { konto.abheben(betrag); return true; }
 }
 // Kontostand abfragen
 public double kontoStand(int kontoNummer) {
   BankKonto konto = this.sucheBankKonto(kontoNummer);
   if (konto == null) {
      // kleinste Zahl zur"uck geben
      // besser w"are ein Fehler!
      return Integer.MIN_VALUE;
   } 
   else {return konto.getKontoStand();}
 }
 // Gesamtsaldo berechnen
 public  double gesamtSaldo() {
  int saldo = 0;                            // lokale Variable
  for (int i = 0; i < anzahlKonten; i++) {
   // Kontostand von Konto zum saldo dazu addieren
   saldo += konten[i].getKontoStand();      
   }
  return saldo;
 }
}
